/* dralib.h */

#define NB_FILTERS 31
typedef struct filter_data_struct {
  int label;  /* nominal nm */
  float trans; /* transmittance coef */
  float tube_sensi; /* sensitivity of tube at filter nm */
  float corr_factor; /* correction factor at filter nm */
  int it;    /* integration time */
  int reg_x;	/* registration offset horizontal */
  int reg_y;	/* registration offset vertical */
} FILTER_DATA;
extern FILTER_DATA filter_data[NB_FILTERS];

#define MAX_AP 9
typedef struct aper_struct {
  char label[7];
  float trans;   /* transmittance */
} APER;
extern APER aper[MAX_AP];

#define IT( U ) (U&0377)
#define AP( U ) ((U>>16)&0377)

#define LUT_XS 200
#define LUT_YS 256
#define LUT_FILENAME "./dralut.imp"
#define IMP1 1
#define IMP3 3
extern float get_lut();
#define XSIZE 256
#define YSIZE 256
#define OFF_AXIS_FILENAME "./draoffax.imp"
extern float *mk_off_axis_image();
extern float off_axis();

#define REGISTER_FILE "./.register"
#define OLD590_FILE "./.old590"
#define GREYCARD_FILE "./.greycard"
#define KODAK_GREY  0.18
#define KODAK_WHITE 0.90
