#include <stdio.h>
#include <string.h>
#include <sys/file.h>
#define O_NDELAY 0 /* blocking input/output */
#define IMP1 1
#define IMP2 2
#define IMP3 3

char progname[31];

char *tail(s)
char *s;
{
char *cp;
  if( 0 == (cp = (strrchr(s,'/'))) ) return(s);
  return(cp + 1);
}

error(s)
char *s;
{
 fprintf(stderr, "%s : %s\n", progname, s);
 exit(1);
}

errorno(s)
char *s;
{
extern errno;
 fprintf(stderr, "%s : %s (errno=%d)\n", progname, s, errno);
 exit(1);
}

read_bytes(fd,cp,b) /* blocking read */
register int fd, b;
register unsigned char *cp;
{
register int n;
  for( ; 0<b; b-=n, cp+=n)
    n = read(fd,cp,b);
  return(n);
}

write_bytes(fd,cp,b) /* blocking write */
register int fd, b;
register unsigned char *cp;
{
register int n;
  for( ; 0<b; b-=n, cp+=n)
    n = write(fd,cp,b);
  return(n);
}

skip_bytes(fd,b)
register int fd, b;
{
#define MIN(A,B) (A<B?A:B)
#define MAXB 1024
register unsigned char cp[MAXB]; 
int n;
  for( ; 0<b; b-=n)
    n = read(fd,cp,MIN(MAXB,b));
  return(n);
}

eof_reached(fp)
FILE *fp;
{
int c;
  switch( c = getc(fp) )
  {
    case EOF : return (1);
	       
    default  : ungetc(c&0377,fp);
	       return (0);
  }
}

read_hdr(fdin, hdrlength, xsize,ysize)
int fdin;
short hdrlength, *xsize, *ysize;
{
unsigned char byte;
  switch( hdrlength )
  {
    case 0 : break;
    case 1 : read_bytes(fdin,&byte,hdrlength);
	     (*xsize) = (*ysize) = byte;
	     break;
    case 4 : read_bytes(fdin,(short *) xsize,2);
             read_bytes(fdin,(short *) ysize,2);
	     break;
    case 32: read_imp_hdr(fdin,xsize,ysize);
             break;
    default: skip_bytes(fdin, hdrlength);
             break;
  }
}
#define IMPHDRLEN 32 /* Can no longer assign this as sizeof(Impvaru) */

read_imp_hdr(fdin,xsize,ysize)
int fdin;
short  *xsize, *ysize;
{
 short type;
  readT_imp_hdr(fdin,&type,xsize,ysize);
  if( type!=IMP1 ) error("image not type IMP1");
}

read2_imp_hdr(fdin,xsize,ysize)
int fdin;
short  *xsize, *ysize;
{
 short type;
  readT_imp_hdr(fdin,&type,xsize,ysize);
  if( type!=IMP2 ) error("image not type IMP1");
}

read3_imp_hdr(fdin,xsize,ysize)
int fdin;
short  *xsize, *ysize;
{
 short type;
  readT_imp_hdr(fdin,&type,xsize,ysize);
  if( type!=IMP3 ) error("image not type IMP1");
}

readT_imp_hdr(fdin,type,xsize,ysize)
int fdin;
short  *type, *xsize, *ysize;
{
 unsigned long userdata;
  readTdata_imp_hdr(fdin,type,&userdata,xsize,ysize);
}

readTdata_imp_hdr(fdin,type,userdata,xsize,ysize)
int fdin;
unsigned long *userdata;
short  *type, *xsize, *ysize;
{
 char buf[IMPHDRLEN];
 long *typep, *xsizep, *ysizep;
  read_bytes( fdin, buf, IMPHDRLEN );
  xsizep = (long *) &buf[12];
  ysizep = (long *) &buf[16];
  typep  = (long *) &buf[20];
  *userdata = *((long *) & buf[28]);
  *xsize = *xsizep; 
  *ysize = *ysizep; 
  *type  = *typep; 
}

write_hdr(fdout, xsize,ysize)
int fdout;
short xsize,ysize;
{
  write_bytes(fdout, &xsize, 2);
  write_bytes(fdout, &ysize, 2);
}


write_imp_hdr(fdout,xsize,ysize)
int fdout;
short  xsize, ysize;
{
  writeT_imp_hdr(fdout,IMP1, xsize,ysize);
}

write2_imp_hdr(fdout,xsize,ysize)
int fdout;
short  xsize, ysize;
{
  writeT_imp_hdr(fdout,IMP2, xsize,ysize);
}

write3_imp_hdr(fdout,xsize,ysize)
int fdout;
short  xsize, ysize;
{
  writeT_imp_hdr(fdout,IMP3, xsize,ysize);
}

writeT_imp_hdr(fdout,type,xsize,ysize)
int fdout;
short  type, xsize, ysize;
{
 writeTdata_imp_hdr( fdout, type, (unsigned long) 0, xsize,ysize );
}

writeTdata_imp_hdr(fdout,type,userdata,xsize,ysize)
int fdout;
unsigned long userdata;
short  type, xsize, ysize;
{
 long *lbuf;
 char *buf;
  buf = (char *) malloc( IMPHDRLEN );
  lbuf = (long *) buf;
  sprintf(buf,"DFIMAG10");
  lbuf[2] = IMPHDRLEN;
  lbuf[3] = xsize;
  lbuf[4] = ysize;
  lbuf[5] = type;
  lbuf[6] = 0;
  lbuf[7] = userdata;
  write_bytes( fdout, buf, IMPHDRLEN );
  free(buf);
}
